<template>
    <v-btn
        v-if="visibleToUser && visible"
        :size="size"
        :icon="icon"
        @click="navigateTo()"
        class="!text-error !bg-error-light"
        :disabled="disabled || loading"
    ></v-btn>
</template>

<script lang="ts" setup>
import { useRouter } from 'vue-router';
import { ref, onMounted } from 'vue';

const router: any = useRouter();
const visibleToUser = ref(true);

const props = defineProps({
    icon: {
        type: String,
        default: 'mdi-trash-can-outline',
    },
    to: {
        type: String,
        default: '',
    },
    size: {
        type: String,
        default: 'small',
    },
    disabled: {
        type: Boolean,
        default: false,
    },
    type: {
        type: String,
        default: 'primary',
    },
    active: {
        type: Boolean,
        default: false,
    },
    loading: {
        type: Boolean,
        default: false,
    },
    visible: {
        type: Boolean,
        default: true,
    },
});

const navigateTo = () => {
    if (props.to !== '') {
        router.push(typeof props.to === 'string' ? { name: props.to } : props.to);
    }
};

onMounted(() => {
    const route = typeof props.to === 'string' ? { name: props.to } : props.to;

    if (Object.keys(router.resolve(route).meta).length > 0) {
        visibleToUser.value = router.resolve(route).meta.permission();
    }
});
</script>
